diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
index 2f9fb5b45..5b8aae3eb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
@@ -25,7 +25,7 @@ public class BlockLogicSnow extends BlockLogic
 	public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         if(world.getSavedLightValue(LightLayer.Block, tilePos) > 11) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
index 6f6fc42de..88bba9d1e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
@@ -52,7 +52,7 @@ public class BlockLogicSpikes extends BlockLogic
     }
 
 	@Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+	public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
 		if(world.isClientSide) {
 			return;
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
index 2405b7b65..507c71d73 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
@@ -25,7 +25,7 @@ public class BlockLogicSponge extends BlockLogic {
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         super.onPlacedByWorld(world, tilePos);
         if ((world.dimension == Dimension.NETHER || inHot(world, tilePos)) && this.isWet) {
-            world.setBlockIdNotify(tilePos, Blocks.SPONGE_DRY.id());
+            world.setBlockTypeNotify(tilePos, Blocks.SPONGE_DRY);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for (int l = 0; l < 8; l++) {
                 world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + Math.random(), (double) tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 0);
@@ -37,14 +37,14 @@ public class BlockLogicSponge extends BlockLogic {
             for (queryPos.x = tilePos.x() - radius; queryPos.x <= tilePos.x() + radius; queryPos.x++) {
                 for (queryPos.y = tilePos.y() - radius; queryPos.y <= tilePos.y() + radius; queryPos.y++) {
                     for (queryPos.z = tilePos.z() - radius; queryPos.z <= tilePos.z() + radius; queryPos.z++) {
-                        if (Blocks.hasTag(world.getBlockId(queryPos), BlockTags.IS_WATER)) {
-                            world.setBlockIdNotify(queryPos, 0);
+                        if (world.getBlockType(queryPos).hasTag(BlockTags.IS_WATER)) {
+                            world.setBlockTypeNotify(queryPos, Blocks.AIR);
 
                         }
                     }
                 }
             }
-            world.setBlockIdNotify(tilePos, Blocks.SPONGE_WET.id());
+            world.setBlockTypeNotify(tilePos, Blocks.SPONGE_WET);
         }
     }
 
@@ -53,7 +53,7 @@ public class BlockLogicSponge extends BlockLogic {
         TilePos queryPos = new TilePos();
         for (int i = 0; i < Direction.directions.length; i++) {
             Direction dir = Direction.directions[i];
-            Block<?> b = world.getBlock(tilePos.add(dir, queryPos));
+            Block<?> b = world.getBlockType(tilePos.add(dir, queryPos));
             if (Blocks.hasTag(b, BlockTags.IS_WATER)) return true;
         }
         return false;
@@ -63,7 +63,7 @@ public class BlockLogicSponge extends BlockLogic {
         TilePos queryPos = new TilePos();
         for (int i = 0; i < Direction.directions.length; i++) {
             Direction dir = Direction.directions[i];
-            Block<?> b = world.getBlock(tilePos.add(dir, queryPos));
+            Block<?> b = world.getBlockType(tilePos.add(dir, queryPos));
             if (b == Blocks.COBBLE_NETHERRACK_IGNEOUS || Blocks.hasTag(b, BlockTags.IS_LAVA)) return true;
         }
         return false;
@@ -77,7 +77,7 @@ public class BlockLogicSponge extends BlockLogic {
             for (queryPos.x = tilePos.x() - radius; queryPos.x <= tilePos.x() + radius; queryPos.x++) {
                 for (queryPos.y = tilePos.y() - radius; queryPos.y <= tilePos.y() + radius; queryPos.y++) {
                     for (queryPos.z = tilePos.z() - radius; queryPos.z <= tilePos.z() + radius; queryPos.z++) {
-                        world.notifyBlocksOfNeighborChange(queryPos, world.getBlockId(queryPos));
+                        world.notifyBlocksOfNeighborChange(queryPos, world.getBlockType(queryPos));
                     }
 
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
index e25b4302d..e4379a2b9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
@@ -307,7 +307,7 @@ public class BlockLogicStairs extends BlockLogic {
 
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
-        onNeighborChanged(world, tilePos, 0);
+        onNeighborChanged(world, tilePos, Blocks.AIR);
         this.modelBlock.onPlacedByWorld(world, tilePos);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPaintable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPaintable.java
index f6ee94654..9a58ebe03 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPaintable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPaintable.java
@@ -13,7 +13,7 @@ public class BlockLogicStairsPaintable extends BlockLogicStairs implements IPain
     @Override
     public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         final int meta = world.getBlockData(tilePos);
-        world.setBlockIdDataNotify(tilePos, Blocks.STAIRS_PLANKS_PAINTED.id(), meta);
+        world.setBlockTypeDataNotify(tilePos, Blocks.STAIRS_PLANKS_PAINTED, meta);
         Blocks.STAIRS_PLANKS_PAINTED.getLogic().setColor(world, tilePos, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPainted.java
index dc039ffc1..979b15c42 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPainted.java
@@ -28,7 +28,7 @@ public class BlockLogicStairsPainted extends BlockLogicStairs implements IPainte
     @Override
     public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
         final int meta = world.getBlockData(tilePos);
-        world.setBlockIdDataNotify(tilePos, Blocks.STAIRS_PLANKS_OAK.id(), stripColorFromMetadata(meta));
+        world.setBlockTypeDataNotify(tilePos, Blocks.STAIRS_PLANKS_OAK, stripColorFromMetadata(meta));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
index 4e1953668..3b424bbb8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
@@ -166,7 +166,7 @@ public class BlockLogicStatue extends BlockLogic {
 
     public @Nullable TileEntityStatue getTileEntity(final @NotNull World world, final @NotNull TilePosc tilePos) {
         TilePosc entPos = this.isBottom ? tilePos : tilePos.down(new TilePos());
-        final @Nullable Block<?> block = world.getBlock(entPos);
+        final @Nullable Block<?> block = world.getBlockType(entPos);
         if (block == null || !(block.getLogic() instanceof BlockLogicStatue)) {
             return null;
         }
@@ -205,15 +205,15 @@ public class BlockLogicStatue extends BlockLogic {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         final Block<?> otherBlock;
         if (!this.isBottom) {
-            otherBlock = world.getBlock(tilePos.down(new TilePos()));
+            otherBlock = world.getBlockType(tilePos.down(new TilePos()));
         } else {
-            otherBlock = world.getBlock(tilePos.up(new TilePos()));
+            otherBlock = world.getBlockType(tilePos.up(new TilePos()));
         }
-        if (!(otherBlock != null && otherBlock.getLogic() instanceof BlockLogicStatue)) {
-            world.setBlockIdNotify(tilePos, 0);
+        if (!(otherBlock.getLogic() instanceof BlockLogicStatue)) {
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStone.java
index 49b6c6f1b..958923672 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStone.java
@@ -43,7 +43,7 @@ public class BlockLogicStone extends BlockLogic {
     public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
 
         Chunk chunk = world.getChunk(tilePos);
-        if (tilePos.y() <= 32 && chunk.getChunkRandom(0x3ad8025fL).nextInt(10) == 0 && world.getBlockId(tilePos.down(new TilePos())) == 0) {
+        if (tilePos.y() <= 32 && chunk.getChunkRandom(0x3ad8025fL).nextInt(10) == 0 && world.getBlockType(tilePos.down(new TilePos())) == Blocks.AIR) {
             if (rand.nextInt(50) == 0)
                 world.spawnParticle("slimechunk", tilePos.x(), tilePos.y(), tilePos.z(), 0.0D, 0.0D, 0.0D, 0);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
index 8dd27b5f6..6358240cf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
@@ -37,14 +37,14 @@ public class BlockLogicSugarcane extends BlockLogic implements IBonemealable {
         if (world.isAirBlock(up)) {
             int reedHeight = 0;
             TilePos p = new TilePos(tilePos);
-            while (world.getBlockId(p) == id()) { // Stop natural reed growth if reed is already 3 blocks tall
+            while (world.getBlockType(p) == this.block) { // Stop natural reed growth if reed is already 3 blocks tall
                 p.y--;
                 if (++reedHeight >= 3) return;
             }
 
             int data = world.getBlockData(tilePos);
             if (data >= 15) {
-                world.setBlockIdNotify(up, id());
+                world.setBlockTypeNotify(up, this.block);
                 world.setBlockDataNotify(tilePos, 0);
             } else {
                 world.setBlockDataNotify(tilePos, data + 1);
@@ -54,18 +54,18 @@ public class BlockLogicSugarcane extends BlockLogic implements IBonemealable {
 
     public void growReedOnTop(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos p = new TilePos(tilePos);
-        while (world.getBlockId(p) == id()) {
+        while (world.getBlockType(p) == this.block) {
             p.y++;
         }
         if (world.isAirBlock(p)) {
-            world.setBlockIdNotify(p, id());
+            world.setBlockTypeNotify(p, this.block);
         }
     }
 
     @Override
     public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
-        Block<?> blockBelow = world.getBlock(tilePos.down(queryPos));
+        Block<?> blockBelow = world.getBlockType(tilePos.down(queryPos));
         if (blockBelow == null) {
             return false;
         } else if (blockBelow.id() == id()) {
@@ -74,21 +74,21 @@ public class BlockLogicSugarcane extends BlockLogic implements IBonemealable {
             return false;
         }
         return
-            Blocks.hasTag(world.getBlockId(tilePos.down(queryPos).add(Direction.WEST, queryPos)), BlockTags.IS_WATER) ||
-                Blocks.hasTag(world.getBlockId(tilePos.down(queryPos).add(Direction.EAST, queryPos)), BlockTags.IS_WATER) ||
-                Blocks.hasTag(world.getBlockId(tilePos.down(queryPos).add(Direction.NORTH, queryPos)), BlockTags.IS_WATER) ||
-                Blocks.hasTag(world.getBlockId(tilePos.down(queryPos).add(Direction.SOUTH, queryPos)), BlockTags.IS_WATER);
+            world.getBlockType(tilePos.down(queryPos).add(Direction.WEST, queryPos)).hasTag(BlockTags.IS_WATER) ||
+            world.getBlockType(tilePos.down(queryPos).add(Direction.EAST, queryPos)).hasTag(BlockTags.IS_WATER) ||
+            world.getBlockType(tilePos.down(queryPos).add(Direction.NORTH, queryPos)).hasTag(BlockTags.IS_WATER) ||
+            world.getBlockType(tilePos.down(queryPos).add(Direction.SOUTH, queryPos)).hasTag(BlockTags.IS_WATER);
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         checkCanStay(world, tilePos);
     }
 
     protected final void checkCanStay(@NotNull World world, @NotNull TilePosc tilePos) {
         if (!canStay(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java
index 7ae29c260..0ecdc1f33 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java
@@ -28,8 +28,8 @@ public class BlockLogicTNT extends BlockLogic {
 	}
 
 	@Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
-		if (id > 0 && world.hasNeighborSignal(tilePos)) {
+	public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+		if (world.hasNeighborSignal(tilePos)) {
 			ignite(world, tilePos, true);
 		}
 	}
@@ -62,7 +62,7 @@ public class BlockLogicTNT extends BlockLogic {
 			}
 			return;
 		}
-		world.setBlockIdNotify(tilePos, 0);
+		world.setBlockTypeNotify(tilePos, Blocks.AIR);
 		EntityPrimedTNT tnt = new EntityPrimedTNT(world, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F);
 		world.entityJoinedWorld(tnt);
 		if (sound) world.playSoundAtEntity(null, tnt, "tile.tnt.fuse", 1.0F, 1.0F);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTallGrass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTallGrass.java
index 0a09cb887..d15c330d3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTallGrass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTallGrass.java
@@ -19,16 +19,15 @@ public class BlockLogicTallGrass extends BlockLogicFlower
     }
 
     @Override
-    protected boolean mayPlaceOn(int blockId) {
-    	Block<?> block = Blocks.getBlock(blockId);
-    	if(block != null && block.getLogic() instanceof BlockLogicMoss) {
+    protected boolean mayPlaceOn(final @NotNull Block<?> block) {
+    	if(block.getLogic() instanceof BlockLogicMoss) {
     		return true;
     	}
-    	return super.mayPlaceOn(blockId);
+    	return super.mayPlaceOn(block);
     }
 
     @Override
-    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity)
+    public @NotNull ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity)
     {
         return switch (dropCause) {
             case PICK_BLOCK, SILK_TOUCH -> new ItemStack[]{new ItemStack(this)};
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
index ad5b45705..57a96ee9c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
@@ -149,7 +149,7 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         boolean invalid;
         int side = world.getBlockData(tilePos) & MASK_DIRECTION;
         invalid = switch (side) {
@@ -162,14 +162,14 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable {
         };
         if (invalid) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, side, null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
     private void dropTorchIfCantStay(@NotNull World world, @NotNull TilePosc tilePos) {
         if (!canPlaceAt(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
index 7d35b4547..a6410530c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
@@ -34,12 +34,12 @@ public class BlockLogicTorchRedstone extends BlockLogicTorch {
         }
         TilePos queryPos = new TilePos();
         if (this.torchActive) {
-            world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), id());
-            world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), id());
-            world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), id());
-            world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), id());
-            world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), id());
-            world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), this.block);
         }
     }
 
@@ -47,12 +47,12 @@ public class BlockLogicTorchRedstone extends BlockLogicTorch {
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         TilePos queryPos = new TilePos();
         if (this.torchActive) {
-            world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), id());
-            world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), id());
-            world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), id());
-            world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), id());
-            world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), id());
-            world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), this.block);
         }
     }
 
@@ -89,17 +89,17 @@ public class BlockLogicTorchRedstone extends BlockLogicTorch {
         boolean isPowered = hasNeighborSignal(world, tilePos);
         if (this.torchActive) {
             if (isPowered) {
-                world.setBlockIdDataNotify(tilePos, Blocks.TORCH_REDSTONE_IDLE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.TORCH_REDSTONE_IDLE, world.getBlockData(tilePos));
             }
         } else if (!isPowered) {
-            world.setBlockIdDataNotify(tilePos, Blocks.TORCH_REDSTONE_ACTIVE.id(), world.getBlockData(tilePos));
+            world.setBlockTypeDataNotify(tilePos, Blocks.TORCH_REDSTONE_ACTIVE, world.getBlockData(tilePos));
         }
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
-        super.onNeighborChanged(world, tilePos, id);
-        world.scheduleBlockUpdate(tilePos, id(), tickDelay());
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        super.onNeighborChanged(world, tilePos, block);
+        world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
index 651e4d8ba..a78b3754a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
@@ -131,13 +131,12 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (world.isClientSide) {
             return;
         }
 
-        Block<?> block = Blocks.getBlock(id);
-        if ((this.material != Materials.METAL && this.material != Materials.STEEL && block != null && block.isSignalSource()) || ((this.material == Materials.METAL || this.material == Materials.STEEL) && (block == null || block.isSignalSource()))) {
+        if (this.material != Materials.METAL && this.material != Materials.STEEL && block.isSignalSource() || (this.material == Materials.METAL || this.material == Materials.STEEL) && block.isSignalSource()) {
             int meta = world.getBlockData(tilePos);
             boolean isOpened = isTrapdoorOpen(meta);
             boolean isPowered = world.hasNeighborSignal(tilePos);
@@ -161,7 +160,7 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     @Override
     public boolean isClimbable(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
-        Block<?> block = world.getBlock(tilePos.down(queryPos));
+        Block<?> block = world.getBlockType(tilePos.down(queryPos));
         int meta = world.getBlockData(tilePos);
         if (isTrapdoorOpen(meta) && (block != null && block.getLogic() instanceof BlockLogicLadder ladder)) {
             Side ladderSide = ladder.getSideFromMeta(world.getBlockData(tilePos.down(queryPos)));
@@ -225,6 +224,6 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     @Override
     public void setColor(World world, @NotNull TilePosc tilePos, DyeColor color) {
         final int meta = world.getBlockData(tilePos);
-        world.setBlockIdDataNotify(tilePos, Blocks.TRAPDOOR_PLANKS_PAINTED.id(), meta & 0xF | color.blockMeta << 4);
+        world.setBlockTypeDataNotify(tilePos, Blocks.TRAPDOOR_PLANKS_PAINTED, meta & 0xF | color.blockMeta << 4);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java
index dd15b32ce..2ccb6b7a0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java
@@ -46,7 +46,7 @@ public class BlockLogicTrapDoorPainted extends BlockLogicTrapDoor implements IPa
     @Override
     public void removeDye(World world, @NotNull TilePosc tilePos) {
         final int meta = world.getBlockData(tilePos);
-        world.setBlockIdDataNotify(tilePos, Blocks.TRAPDOOR_PLANKS_OAK.id(), meta & 0xF);
+        world.setBlockTypeDataNotify(tilePos, Blocks.TRAPDOOR_PLANKS_OAK, meta & 0xF);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
index 68c92b2e3..5abc8fb0c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
@@ -69,17 +69,17 @@ public class BlockLogicTrommel extends BlockLogicRotatable
             if(Global.BUILD_CHANNEL.isUnstableBuild()) {
                 throw new RuntimeException(msg);
             }
-            world.setBlockIdNotify(tilepos, 0);
+            world.setBlockTypeNotify(tilepos, Blocks.AIR);
             LOGGER.warn(msg);
             return;
         }
         keepTrommelInventory = true;
         if(lit)
         {
-            world.setBlockIdNotify(tilepos, Blocks.TROMMEL_ACTIVE.id());
+            world.setBlockTypeNotify(tilepos, Blocks.TROMMEL_ACTIVE);
         } else
         {
-            world.setBlockIdNotify(tilepos, Blocks.TROMMEL_IDLE.id());
+            world.setBlockTypeNotify(tilepos, Blocks.TROMMEL_IDLE);
         }
         keepTrommelInventory = false;
         world.setBlockDataNotify(tilepos, data);
